package ru.dbotthepony.kstarbound

import org.apache.logging.log4j.LogManager
import org.lwjgl.Version
import org.lwjgl.glfw.GLFW.*
import org.lwjgl.opengl.GL46.*
import ru.dbotthepony.kstarbound.client.StarboundClient
import ru.dbotthepony.kstarbound.math.Matrix4f
import ru.dbotthepony.kstarbound.client.render.Camera
import ru.dbotthepony.kstarbound.client.render.ChunkRenderer
import ru.dbotthepony.kstarbound.client.render.TextAlignX
import ru.dbotthepony.kstarbound.client.render.TextAlignY
import ru.dbotthepony.kstarbound.defs.TileDefinition
import ru.dbotthepony.kstarbound.util.Color
import ru.dbotthepony.kstarbound.util.formatBytesShort
import ru.dbotthepony.kstarbound.world.CHUNK_SIZE_FF
import ru.dbotthepony.kstarbound.world.Chunk
import ru.dbotthepony.kstarbound.world.ChunkPos
import java.io.File
import java.util.*

private val LOGGER = LogManager.getLogger()

fun main() {
	LOGGER.info("Running LWJGL ${Version.getVersion()}")

	val client = StarboundClient()

	Starbound.addFilePath(File("./unpacked_assets/"))

	Starbound.initializeGame { finished, replaceStatus, status ->
		client.pushLoadingText(status, replaceStatus)
	}

	client.onTermination {
		Starbound.terminateLoading = true
	}

	var chunkA: Chunk? = null

	Starbound.onInitialize {
		chunkA = client.world!!.computeIfAbsent(ChunkPos(0, 0)).chunk
		val chunkB = client.world!!.computeIfAbsent(ChunkPos(-1, 0)).chunk

		var x = 0
		var y = 0

		for (tile in Starbound.tilesAccess.values) {
			chunkA!!.background[x, y + 1] = tile
			chunkA!!.background[x++, y] = tile

			if (x >= 31) {
				x = 0
				y += 2
			}
		}

		x = 0
		y = 0

		for (tile in Starbound.tilesAccess.values) {
			chunkB.foreground[x, y + 1] = tile
			chunkB.foreground[x++, y] = tile

			if (x > 31) {
				x = 0
				y += 2
			}
		}

		val tile = Starbound.getTileDefinition("alienrock")

		for (x in 0 .. 31) {
			for (y in 0 .. 31) {
				chunkA!!.foreground[x, y] = tile
			}
		}

		for (x in 4 .. 8) {
			for (y in 4 .. 8) {
				chunkA!!.foreground[x, y] = null as TileDefinition?
			}
		}
	}

	val rand = Random()

	while (client.renderFrame()) {
		Starbound.pollCallbacks()

		if (chunkA != null && glfwGetTime() < 10.0) {
			val tile = Starbound.getTileDefinition("alienrock")
			//chunkA!!.foreground[rand.nextInt(0, CHUNK_SIZE_FF), rand.nextInt(0, CHUNK_SIZE_FF)] = tile
		}
	}
}
