package ru.dbotthepony.kstarbound.util

import com.google.common.collect.ImmutableList
import com.google.gson.JsonArray
import ru.dbotthepony.kstarbound.api.IStruct4f

data class Color(val red: Float, val green: Float, val blue: Float, val alpha: Float = 1f) : IStruct4f {
	constructor(input: JsonArray) : this(input[0].asFloat / 255f, input[1].asFloat / 255f, input[2].asFloat / 255f, if (input.size() >= 4) input[3].asFloat / 255f else 1f)

	companion object {
		val WHITE = Color(1f, 1f, 1f)
		val SLATE_GREY = Color(0.2f, 0.2f, 0.2f)

		val SHADES_OF_GRAY = ArrayList<Color>().let {
			for (i in 0 .. 256) {
				it.add(Color(i / 256f, i / 256f, i / 256f))
			}

			return@let ImmutableList.copyOf(it) as List<Color>
		}
	}
}
